/*
UC: 21178 - Laboratorio de Programacao
Ano 2018/19    E-folio A

Sistema de gestao de inscricoes na LEI - Universidade Aberta

Grupo de trabalho:

- Sonia Violante  n. 1100135
- Claudia Pires   n. 1303334

Ficheiro: ReportC.c

Report C: Indicacao do Regime de tempo de cada aluno (parcial, integral
ou situacao irregular):
                   - Parcial: entre 6 e 60 ECTS
                   - Integral: 60 a 84 ECTS
                   - Irregular: nao cumpre nenuma das condicoes anteriores
*/
#include <stdio.h>
#include <stdlib.h>

#include "globals.h"
#include "ucs.h"
#include "inscricoes.h"
#include "alunos.h"
#include "valida.h"


void regime_aluno()
{
    INSCRICOES r_inscricao;
    ALUNOS r_aluno;
    int l_total_ects = 0;

    cabecalho("Indicacao do Regime de Aluno");


    FILE *arq = abrir_ficheiro("alunos.dat","rb");
    if (arq != NULL)
    {
        int l_ano = pergunta_numero("Ano Letivo: ");
        printf(" Ano Lectivo: %d / %d", l_ano, (l_ano + 1));
        linha();
        printf("\nALUNO                                  Regime");
         printf("\n-------------------------------------------------------------------");

        while ( fread( &r_aluno, 1, sizeof(r_aluno), arq ) == sizeof(r_aluno) )
        {
            if (r_aluno.eliminado == 0)  // Testa se este aluno esta ativo e nao eliminado
            {
                FILE *arq2 = abrir_ficheiro("inscricoes.dat","rb");
                if (arq2 != NULL)
                {
                    l_total_ects = 0; // Passa a zero para cada aluno, antes de ler as inscricoes
                    while (fread( &r_inscricao,1,sizeof(r_inscricao), arq2) == sizeof(r_inscricao) )
                    {
                        if ((r_inscricao.eliminado == 0 ) &&     // exclui as inscricoes que foram anuladas
                            (r_aluno.numero==r_inscricao.n_aluno) && (r_inscricao.ano == l_ano))
                        {
                            l_total_ects = l_total_ects + valor_ects_uc(r_inscricao.n_uc);
                        }

                    }
                    // Depois de somar os ECTS de todas as inscricoes desse aluno para aquele ano
                    // imprime os dados do aluno e qual o regime em que se encontra
                    printf("\n%d    %-30s ",r_aluno.numero, r_aluno.nome);
                    if ((l_total_ects)>=6 && (l_total_ects) <= 60)
                    {
                        printf("Regime Parcial (%d ects)",l_total_ects);
                    }
                    else
                        if ((l_total_ects) > 60 && (l_total_ects) <= 84 )
                        {
                            printf("Regime Integral (%d ects)",l_total_ects);
                        }
                        else
                        {
                            printf("Situacao Irregular (%d ects)",l_total_ects);
                        }
                }
                fechar_ficheiro(arq2);
            }
        }
        printf("\n------------------------(Fim do REPORT C)--------------------------");
        pause();  // Faz uma pausa no fim de mostrar todos os alunos/regime
        fechar_ficheiro(arq);
    }
}


// Fim de ficheiro ReportC.c

