/*
UC: 21178 - Laboratorio de Programacao
Ano 2018/19    AF 2

Sistema de gestao de inscricoes na LEI - Universidade Aberta

Grupo 7: Los Mariachis

- Nelson Domingos n. 1002960
- Sonia Violante  n. 1100135
- Claudia Pires   n. 1303334
- Paulo Silva     n. 1303918

Ficheiro: alunos.c

MODULO 4 - ALUNOS

*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <locale.h>
#include <time.h>

#include "globals.h"
#include "alunos.h"
#include "propinas.h"
#include "valida.h"



/*
   Mostrar registo de Aluno
*/
void mostrar_aluno(ALUNOS* p_aluno)
{

   linha();
   printf("Numero:        %d ",p_aluno->numero);
   linha();
   printf("Nome:          %s ", p_aluno->nome);
   linha();
   printf("Morada:        %s ", p_aluno->morada);
   linha();
   printf("Localidade:    %s ", p_aluno->localidade);
   linha();
   printf("Cod. Postal:   %s ",p_aluno->codpostal);
   linha();
   printf("Pais:          %s ", p_aluno->pais);
   linha();
   printf("D.Nascimento:  %d-%d-%d ",p_aluno->nascimento.dia,p_aluno->nascimento.mes,p_aluno->nascimento.ano);
   linha();
   printf("Nacionalidade: %s ",p_aluno->nacionalidade);
   linha();
   printf("Email:         %s ", p_aluno->email);
   linha();
   printf("Contato:       %s ", p_aluno->contato);
   linha();
   printf("Resid.PT(S/N): %c ", p_aluno->residente);
   linha();

   float l_valor = calc_propinas(p_aluno->numero, p_aluno->residente);
   printf("Propinas:      %.2f ", l_valor);
   linha();

}


/*
   Inserir aluno
*/
void ins_aluno()
{
   ALUNOS r_aluno;
   r_aluno.eliminado=0; // Quando é criado o registo fica a 0, so eh 1 se for eliminado
   char l_nome_aluno[30];
   int l_existe = 0;

   FILE *arq = abrir_ficheiro("alunos.dat", "ab");
   if (arq != NULL)
   {
      do
      {
         cabecalho("Alunos: Inserir");
         linha();
         clear_buffer();
         printf("Numero (999-Sair): ");
         scanf("%d",&r_aluno.numero);
         l_existe = 0;
         if (cons_aluno(l_nome_aluno, r_aluno.numero, 0, 1) == 1)
         {
           l_existe = 1;
           linha();
           printf("Aluno ja existe com o nome %s ", l_nome_aluno);
           pause();
         }
      }
      while (l_existe == 1);

      if (r_aluno.numero != 999)
      {
         clear_buffer();
         printf("Nome:              ");
         fgets(r_aluno.nome,30,stdin);
         strtok(r_aluno.nome, "\n");

         clear_buffer();
         printf("Morada:            ");
         fgets(r_aluno.morada,50,stdin);
         strtok(r_aluno.morada, "\n");

         clear_buffer();
         printf("Localidade:        ");
         fgets(r_aluno.localidade,15,stdin);
         strtok(r_aluno.localidade, "\n");

         clear_buffer();
         printf("Codigo Postal:     ");
         fgets(r_aluno.codpostal,15,stdin);
         strtok(r_aluno.codpostal, "\n");

         clear_buffer();
         printf("Pais:              ");
         fgets(r_aluno.pais,10,stdin);
         strtok(r_aluno.pais, "\n");

         clear_buffer();
         printf("D.Nasc.[DD MM AAAA]: ");
         scanf("%d %d %d",&r_aluno.nascimento.dia,&r_aluno.nascimento.mes,&r_aluno.nascimento.ano);

         clear_buffer();
         printf("Nacionalidade:     ");
         fgets(r_aluno.nacionalidade,10,stdin);
         strtok(r_aluno.nacionalidade, "\n");

         clear_buffer();
         printf("Email:             ");
         fgets(r_aluno.email,30,stdin);
         strtok(r_aluno.email, "\n");

         clear_buffer();
         printf("Contato Telemovel: ");
         fgets(r_aluno.contato,10,stdin);
         strtok(r_aluno.contato, "\n");

         int tmp;
         do
         {
            clear_buffer();
            printf("Residente PT(S/N):");
            scanf("%c",&r_aluno.residente);
            tmp = toupper(r_aluno.residente);
            if (tmp != 'S' && tmp != 'N')
            {
               printf ("\nValor Inválido");
               linha();
            }
         }
         while (tmp != 'S' && tmp != 'N');
         r_aluno.residente =(char)tmp;

         clear_buffer();
         linha();
         char l_gravar = gravar("Gravar Aluno ");
         if (l_gravar == 'S')
         {
            fwrite(&r_aluno, sizeof(r_aluno),1,arq);
         }
      }
      fclose(arq);
   }
}


/*
   Modificar informações de aluno
*/
void mod_aluno()
{
    ALUNOS r_aluno;

    cabecalho("Alunos: Modificar");
    FILE *arq = abrir_ficheiro("alunos.dat", "r+b");
    if (arq != NULL)
    {
       int l_existe = 0;
       int l_numero=pergunta_numero("Numero Aluno a modificar:");
       while(fread(&r_aluno,1,sizeof(r_aluno),arq)==sizeof(r_aluno))
       {
          if(r_aluno.numero==l_numero && r_aluno.eliminado==0)
          {
            mostrar_aluno(&r_aluno);
            l_existe = 1;

            clear_buffer();
            printf("Nome:              ");
            fgets(r_aluno.nome,30,stdin);
            strtok(r_aluno.nome, "\n");

            clear_buffer();
            printf("Morada:            ");
            fgets(r_aluno.morada,50,stdin);
            strtok(r_aluno.morada, "\n");

            clear_buffer();
            printf("Localidade:        ");
            fgets(r_aluno.localidade,15,stdin);
            strtok(r_aluno.localidade, "\n");

            clear_buffer();
            printf("Codigo Postal:     ");
            fgets(r_aluno.codpostal,15,stdin);
            strtok(r_aluno.codpostal, "\n");

            clear_buffer();
            printf("Pais:              ");
            fgets(r_aluno.pais,10,stdin);
            strtok(r_aluno.pais, "\n");

            clear_buffer();
            printf("D.Nasc.[DD MM AAAA]: ");
            scanf("%d %d %d",&r_aluno.nascimento.dia,&r_aluno.nascimento.mes,&r_aluno.nascimento.ano);

            clear_buffer();
            printf("Nacionalidade:     ");
            fgets(r_aluno.nacionalidade,10,stdin);
            strtok(r_aluno.nacionalidade, "\n");

            clear_buffer();
            printf("Email:             ");
            fgets(r_aluno.email,30,stdin);
            strtok(r_aluno.email, "\n");

            clear_buffer();
            printf("Contato Telemovel: ");
            fgets(r_aluno.contato,10,stdin);
            strtok(r_aluno.contato, "\n");

            int tmp;
            do
            {
               clear_buffer();
               printf("Residente PT(S/N):");
               scanf("%c",&r_aluno.residente);
               tmp = toupper(r_aluno.residente);
               if (tmp != 'S' && tmp != 'N')
               {
                  printf ("\nValor Inválido");
                  linha();
               }
            }
            while (tmp != 'S' && tmp != 'N');
            r_aluno.residente =(char)tmp;

            clear_buffer();
            linha();
            if (gravar("Gravar alteracoes (S/N) ") == 'S')
            {
               fseek(arq,-sizeof(r_aluno),SEEK_CUR);
               fwrite(&r_aluno, sizeof(r_aluno),1,arq);
            }
            break;
         }
      }
      fechar_ficheiro(arq);
      if (l_existe == 0)
      {
         linha();
         mensagem ("Registo Inexistente");
      }
   }
}


/*
  Funcao de consulta de alunos
      - Nome a retornar
      - Numero a consultar
      - Eliminados    0 - Nao   1 - Sim
      - Silencio      0 - Nao   1 - Sim (nao envia mensagens para o ecran)
*/
int cons_aluno(char* p_nome, int p_numero, int p_eliminado, int p_silencio)
{
   ALUNOS r_aluno;
   int l_existe = 0;

   if (p_silencio == 0)
   {
   cabecalho("Alunos: Consultar");
   }

   FILE *arq = abrir_ficheiro("alunos.dat", "rb");
   if (arq != NULL)
   {
      if (p_numero == 0 && p_silencio == 0)
             p_numero =  pergunta_numero("Numero aluno ( 0-Todos) ? ");
      l_existe = 0;
      while(fread(&r_aluno,1,sizeof(r_aluno),arq)==sizeof(r_aluno))
      {
         if ((r_aluno.numero==p_numero||p_numero==0) && (r_aluno.eliminado==p_eliminado))
         {
            l_existe = 1;
            strcpy(p_nome, r_aluno.nome); // Necessário usar strcpy para manipular uma string
            if (p_silencio == 0)
            {
               cabecalho("Alunos: Consultar");
               mostrar_aluno(&r_aluno); //não está a mostrar no ecrã as informações do aluno
               pause();
            }
         }
      }
      fechar_ficheiro(arq);
      if (p_silencio == 0 && l_existe == 0)
      {
         linha();
         mensagem ("Registo Inexistente");
      }

   }

   return l_existe;
}


/*
   Eliminar UC
*/
void eli_aluno()
{
   ALUNOS r_aluno;

   cabecalho("UCs: Eliminar");

   FILE *arq = abrir_ficheiro("alunos.dat", "r+b");
   if (arq != NULL)
   {
      int l_existe = 0;
      int l_numero =  pergunta_numero("Numero Aluno ? ");

      while ( fread( &r_aluno, 1, sizeof(r_aluno), arq ) == sizeof(r_aluno) )
      {
         if ( r_aluno.numero == l_numero && r_aluno.eliminado == 0 )
         {
            mostrar_aluno(&r_aluno);
            l_existe = 1;
            linha();

            // Valida integridade referencial
            // 0 - Aluno 1 - UC
            if (valida_int_referencial( 0,r_aluno.numero) == 0)
            {
               if (gravar("Eliminar Aluno") == 'S')
               {
                  r_aluno.eliminado = 1;
                  fseek(arq,-sizeof(r_aluno),SEEK_CUR);
                  fwrite(&r_aluno, sizeof(r_aluno),1,arq);
               }
            }
            else
            {
               mensagem ("Este Aluno nao pode ser eliminado, tem inscricoes ativas");
            }
            break;
         }
      }
      fechar_ficheiro(arq);
      if (l_existe == 0)
      {
         linha();
         mensagem ("Registo Inexistente");
      }
   }
}


/*
   Funcao para Mostrar Valor das Propinas de cada aluno
*/
void mostrar_propinas(ALUNOS* p_aluno)
{

   printf(" %d - %s                              %.2f         %c", p_aluno->numero, p_aluno->nome,
            calc_propinas(p_aluno->numero, p_aluno->residente), p_aluno->residente);
   linha();
}


/*
   Listar Propinas
*/
void lis_propinas()
{
   ALUNOS r_aluno;

   cabecalho("Propinas: Listar Valor por Aluno");

   FILE *arq = abrir_ficheiro("alunos.dat", "rb");
   if (arq != NULL)
   {
      linha();
      printf("------------------------------------------------------------------");
      linha();
      printf(" Aluno                                        Propinas      Resid.");
      linha();
      int l_existe = 0;
      while(fread(&r_aluno,1,sizeof(r_aluno),arq)==sizeof(r_aluno))
      {
         if (r_aluno.eliminado==0)
         {
            l_existe = 1;
            mostrar_propinas(&r_aluno);
            pause();
         }
      }
      fechar_ficheiro(arq);
      if (l_existe == 0)
      {
         linha();
         mensagem ("Nao Existem Registos");
      }
   }
}


// Fim ficheiro "alunos.c"
