/*
UC: 21178 - Laboratorio de Programacao
Ano 2018/19    AF 2

Sistema de gestao de inscricoes na LEI - Universidade Aberta

Grupo 7: Los Mariachis

- Nelson Domingos n. 1002960
- Sonia Violante  n. 1100135
- Claudia Pires   n. 1303334
- Paulo Silva     n. 1303918

Ficheiro: inscricoes.c

MODULO 5 - ALUNOS
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <locale.h>
#include <time.h>

#include "globals.h"
#include "ucs.h"
#include "inscricoes.h"
#include "alunos.h"
#include "valida.h"


/*
   Insere inscricoes Aluno/UC
*/
void ins_inscricao()
{
   INSCRICOES r_inscricao;
   char l_nome_aluno[30];
   char l_nome_uc[30];
   int l_existe = 0;

   FILE *arq = abrir_ficheiro("inscricoes.dat", "ab");
   if (arq != NULL)
   {
      cabecalho("Inscricoes: Inserir");
      linha();

      clear_buffer();
      printf("Numero Aluno: ");
      scanf("%d",&r_inscricao.n_aluno);
      if (cons_aluno(l_nome_aluno, r_inscricao.n_aluno, 0, 1) == 1)
      {
         printf("           %s ",l_nome_aluno);
         linha();
      }
      else
      {
        printf("\nRegisto Inexistente");
      }

      clear_buffer();
      printf("Numero UC:    ");
      scanf("%d",&r_inscricao.n_uc);
      if (cons_uc(l_nome_uc, 0, r_inscricao.n_uc, 0, 1) == 1)
      {
         printf("           %s ",l_nome_uc);
         linha();
      }
      else
      {
        printf("\nRegisto Inexistente");
      }
      clear_buffer();
      printf("Ano Lectivo:  ");
      scanf("%d",&r_inscricao.ano);

      l_existe = valida_inscricao(r_inscricao.n_aluno,r_inscricao.n_uc, r_inscricao.ano);
      if (l_existe == 0)
      {
         int l_erro = valida_ects(r_inscricao.n_aluno, r_inscricao.n_uc, r_inscricao.ano);
         linha();
         if (l_erro == 0)
         {
            printf(" Ano Lectivo: %d / %d", r_inscricao.ano, (r_inscricao.ano + 1));
            linha();
            if (gravar("Inserir Inscricao ") == 'S')
            {
                r_inscricao.eliminado = 0;
               // Acrescenta registo no fim do ficheiro
               fwrite(&r_inscricao, sizeof(r_inscricao),1,arq);
            }
         }
      }
      else
      {
         if (l_existe == 1)
         {
            linha();
            printf("Aluno ja esta inscrito nesta UC no Ano indicado");
         }
         else
         {
            linha();
            printf("Aluno ja esteve inscrito nesta UC no Ano indicado mas anulou");
         }
         pause();
      }
      fechar_ficheiro(arq);
   }
}


/*
   Mostrar registo de inscricoes
*/
void mostrar_inscricao(INSCRICOES* p_inscricao)
{
   char l_nome_aluno[30];
   char l_nome_uc[30];

   printf("\nAluno: %d", p_inscricao->n_aluno);
   if (cons_aluno(l_nome_aluno, p_inscricao->n_aluno, 0, 1) == 1)
   {
      printf("           %s",l_nome_aluno);
   }
   else
   {
      printf("\nRegisto Inexistente");
   }
   printf("\nUC:    %d", p_inscricao->n_uc);
   if (cons_uc(l_nome_uc,0, p_inscricao->n_uc, 0, 1) == 1)
   {
      printf("           %s",l_nome_uc);
   }
   else
   {
      printf("\nRegisto Inexistente");
   }

   printf("\nAno Lectivo: %d / %d", p_inscricao->ano, (p_inscricao->ano + 1));
   linha();
}


/*
   Consulta Inscricao
*/
void cons_inscricao()
{
   INSCRICOES r_inscricao;

   cabecalho("Inscricoes: Consultar");

   FILE *arq = abrir_ficheiro("inscricoes.dat","rb");
   if (arq != NULL)
   {
      int l_numero =  pergunta_numero("Numero Aluno ( 0 - Todos) ? ");
      int l_existe = 0;

      while ( fread( &r_inscricao, 1, sizeof(r_inscricao), arq ) == sizeof(r_inscricao) )
      {
         if ( (r_inscricao.n_aluno == l_numero || l_numero == 0 ) && (r_inscricao.eliminado == 0) )
         {
            cabecalho("Inscricoes: Consultar");
            mostrar_inscricao(&r_inscricao);
            l_existe = 1;
            pause();
         }
      }
      fechar_ficheiro(arq);
      if (l_existe == 0)
      {
         linha();
         mensagem ("Registo Inexistente");
      }
   }
}


/*
   Modificar INSCRICOES
*/
void mod_inscricao()
{
   INSCRICOES r_inscricao;
   char l_nome_aluno[30];
   char l_nome_uc[30];
   int l_existe = 0;
   int l_valida = 0;

   cabecalho("INSCRICOES: Modificar");

   FILE *arq = abrir_ficheiro("inscricoes.dat", "r+b");
   if (arq != NULL)
   {
      int l_n_aluno =  pergunta_numero("Numero Aluno? ");
      if (cons_aluno(l_nome_aluno,l_n_aluno, 0, 1) == 1)
         printf("           %s",l_nome_aluno);

      int l_n_uc    =  pergunta_numero("Numero UC? ");
      if (cons_uc(l_nome_uc,0, l_n_uc, 0, 1) == 1)
         printf("           %s",l_nome_uc);

      int l_ano    =  pergunta_numero("Ano Lectivo? ");
      printf("Ano Lectivo: %d / %d", l_ano, (l_ano + 1));

      while ( fread( &r_inscricao, 1, sizeof(r_inscricao), arq ) == sizeof(r_inscricao) )
      {
         if ( r_inscricao.n_aluno == l_n_aluno &&
              r_inscricao.n_uc == l_n_uc &&
              r_inscricao.ano == l_ano &&
              r_inscricao.eliminado == 0
            )
         {
            mostrar_inscricao(&r_inscricao);
            l_existe = 1;
            pause();

            clear_buffer();
            printf("Ano Lectivo: ");
            scanf("%d",&r_inscricao.ano);

            l_valida = valida_inscricao(r_inscricao.n_aluno,r_inscricao.n_uc, r_inscricao.ano);
            if (l_valida == 0)
            {
               linha();
               printf(" Ano Lectivo: %d / %d", r_inscricao.ano, (r_inscricao.ano + 1));
               linha();
               if (gravar("Modificar Inscricao") == 'S')
               {
                  fseek(arq,-sizeof(r_inscricao),SEEK_CUR);
                  fwrite(&r_inscricao, sizeof(r_inscricao),1,arq);
               }
            }
            else
            {
               if (l_valida == 1)
               {
                  linha();
                  printf("Aluno ja esta inscrito nesta UC no Ano indicado");
               }
               else
               {
                  linha();
                  printf("Aluno ja esteve inscrito nesta UC no Ano indicado mas anulou");
               }
               pause();
            }
            break;
         }
      }
      fechar_ficheiro(arq);
      if (l_existe == 0)
      {
         linha();
         mensagem ("Registo Inexistente");
      }
   }
}


/*
   Eliminar Inscricao
*/
void eli_inscricao()
{
   INSCRICOES r_inscricao;
   char l_nome_aluno[30];
   char l_nome_uc[30];
   int l_existe = 0;

   cabecalho("Inscricoes: Anular");

   FILE *arq = abrir_ficheiro("inscricoes.dat", "r+b");
   if (arq != NULL)
   {
      int l_n_aluno =  pergunta_numero("Numero Aluno? ");
      if (cons_aluno(l_nome_aluno,l_n_aluno, 0, 1) == 1)
         printf("           %s",l_nome_aluno);

      int l_n_uc    =  pergunta_numero("Numero UC? ");
      if (cons_uc(l_nome_uc,0, l_n_uc, 0, 1) == 1)
         printf("           %s",l_nome_uc);

      int l_ano    =  pergunta_numero("Ano Lectivo? ");
      printf("Ano Lectivo: %d / %d", l_ano, (l_ano + 1));

      while ( fread( &r_inscricao, 1, sizeof(r_inscricao), arq ) == sizeof(r_inscricao) )
      {
         if ( r_inscricao.n_aluno == l_n_aluno &&
              r_inscricao.n_uc == l_n_uc &&
              r_inscricao.ano == l_ano &&
              r_inscricao.eliminado == 0
            )
         {
            mostrar_inscricao(&r_inscricao);
            l_existe = 1;

            if (gravar("Anular Inscricao") == 'S')
            {
                r_inscricao.eliminado = 1;
                fseek(arq,-sizeof(r_inscricao),SEEK_CUR);
                fwrite(&r_inscricao, sizeof(r_inscricao),1,arq);
             }
             break;
         }
      }
      fechar_ficheiro(arq);
      if (l_existe == 0)
      {
         linha();
         mensagem ("Registo Inexistente");
      }
   }
}


/*
   Funcao para escrever dados de UCs
*/
void mostrar_lista_ucs(INSCRICOES* p_inscricao)
{
   char  l_nome[30];

   cons_uc(l_nome,0, p_inscricao->n_uc, 0, 1);
   printf(" %d / %d     %d - %s", p_inscricao->ano, (p_inscricao->ano + 1), p_inscricao->n_uc, l_nome);
   linha();
}


/*
   Funcao para escrever lista de alunos
*/
void mostrar_lista_alunos(INSCRICOES* p_inscricao)
{
   char l_nome_aluno[30];

   cons_aluno(l_nome_aluno, p_inscricao->n_aluno, 0, 1) ;
   printf("%d - %s  %d / %d", p_inscricao->n_aluno, l_nome_aluno, p_inscricao->ano, (p_inscricao->ano + 1));
   linha();
}

/*
   Listar UCs por Aluno
*/
void lis_ucs_aluno()
{
   INSCRICOES r_inscricao;
   char l_nome_aluno[30];

   cabecalho("Inscricoes: Listar UCS por Aluno");

   FILE *arq = abrir_ficheiro("inscricoes.dat","rb");
   if (arq != NULL)
   {
      int l_numero =  pergunta_numero("Numero Aluno? ");
      if (cons_aluno(l_nome_aluno, l_numero, 0, 1) == 1)
      {
         printf("           %s ",l_nome_aluno);
         linha();
         printf("-----------------------------------------------------------------");
         linha();
         printf(" ANO             UC ");
         linha();
         while ( fread( &r_inscricao, 1, sizeof(r_inscricao), arq ) == sizeof(r_inscricao) )
         {
            if ( (r_inscricao.n_aluno == l_numero) && (r_inscricao.eliminado == 0) )
            {
               mostrar_lista_ucs(&r_inscricao);
            }
         }
         pause();
      }
      else
      {
        linha();
        mensagem("Registo Inexistente");
        linha();
      }
      fechar_ficheiro(arq);
   }
}


/*
   Listar Alunos inscritos numa UC
*/
void lis_alunos_uc()
{
   INSCRICOES r_inscricao;
   char l_nome_uc[30];

   cabecalho("Inscricoes: Listar Aluno inscritos numa UC");

   FILE *arq = abrir_ficheiro("inscricoes.dat","rb");
   if (arq != NULL)
   {
      int l_numero =  pergunta_numero("Numero UC? ");
      if (cons_uc(l_nome_uc,0, l_numero, 0, 1) == 1)
      {
         printf("           %s ",l_nome_uc);
         linha();
         printf("-----------------------------------------------");
         linha();
         printf("    Aluno    ");
         linha();
         while ( fread( &r_inscricao, 1, sizeof(r_inscricao), arq ) == sizeof(r_inscricao) )
         {
            if ( (r_inscricao.n_uc == l_numero) && (r_inscricao.eliminado == 0) )
            {
               mostrar_lista_alunos(&r_inscricao);
            }
         }
         pause();
      }
      else
      {
        linha();
        mensagem("Registo Inexistente");
        linha();
      }

      fechar_ficheiro(arq);
   }
}


// Fim ficheiro "inscricoes.c"

