/*
UC: 21178 - Laboratorio de Programacao
Ano 2018/19    AF 2

Sistema de gestao de inscriaoes na LEI - Universidade Aberta

Grupo 7: Los Mariachis

- Nelson Domingos n. 1002960
- Sonia Violante  n. 1100135
- Claudia Pires   n. 1303334
- Paulo Silva     n. 1303918

Ficheiro: propinas.c

MODULO 7 - ALUNOS
*/

#include <stdlib.h>
#include <stdio.h>
#include "globals.h"
#include "inscricoes.h"
#include "valida.h"

/*
   Funcao para calculo do valor de propinas a pagar
   - p_n_aluno -> numero do aluno a calcular a propina
   - p_residente -> residente em Portugal (S/N) - nao residentes tem agravamento de 20%
*/
float calc_propinas(int p_n_aluno, char p_residente)
{
    INSCRICOES r_inscricao;
    int l_ano_max = 0;
    int l_ano_min = 9999;
    int l_total_ects = 0;

   FILE *arq = abrir_ficheiro("inscricoes.dat","rb");
   if (arq != NULL)
   {
      while ( fread( &r_inscricao, 1, sizeof(r_inscricao), arq ) == sizeof(r_inscricao) )
      {
         if (r_inscricao.n_aluno == p_n_aluno && r_inscricao.eliminado == 0)
         {
            if(r_inscricao.ano > l_ano_max)
            {
               l_ano_max = r_inscricao.ano;
               l_total_ects = 0;
            }
            if(r_inscricao.ano < l_ano_min)
            {
               l_ano_min = r_inscricao.ano;
            }
            if ( r_inscricao.ano == l_ano_max )
            {
               l_total_ects = l_total_ects + valor_ects_uc(r_inscricao.n_uc);
            }
         }
      }
   }
   fechar_ficheiro(arq);

   float l_valor = 0.0;

   if (l_ano_max == l_ano_min) // Se o ano max e min sao iguais entao eh o 1o ano inscrito
   {
      l_valor = 80.00;  // No 1o ano paga uma taxa de 80.00
   }

   l_valor =  l_valor + (l_total_ects * 15); // Cada ECTS custa 15


   if (p_residente == 'N')
   {
      l_valor = l_valor * 1.2;  // Caso o aluno nao seja residente em PT tem agravamento de 20%
                                // sobre o valor total a pagar
   }

   return l_valor;
}


// fim ficheiro "propinas.c"

