/*
UC: 21178 - Laboratorio de Programacao
Ano 2018/19    AF 2

Sistema de gestao de inscricoes na LEI - Universidade Aberta

Grupo 7: Los Mariachis

- Nelson Domingos n. 1002960
- Sonia Violante  n. 1100135
- Claudia Pires   n. 1303334
- Paulo Silva     n. 1303918

Ficheiro: ucs.c

MODULO 6 - UCS
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <locale.h>
#include <time.h>

#include "globals.h"
#include "ucs.h"
#include "valida.h"


/*
   Insere UC (Unidade Curricular)
*/
void ins_uc()
{
   UCS r_uc;
   char l_nome_uc[30];
   int l_existe = 0;


   FILE *arq = abrir_ficheiro("ucs.dat", "ab");
   if (arq != NULL)
   {
      do
      {
         cabecalho("UCs: Inserir");
         linha();
         printf("UC: ");
         clear_buffer();
         printf("Numero: (999-Sair) ");
         scanf("%d",&r_uc.numero);
         l_existe = 0;
         if (cons_uc(l_nome_uc, 0,r_uc.numero, 0, 1) == 1)
         {
           l_existe = 1;
           printf("\nUC ja existe com o nome %s ", l_nome_uc);
           pause();
         }
      }
      while (l_existe == 1);

      if (r_uc.numero != 999)
      {
         clear_buffer();
         printf("Nome:    ");
         fgets(r_uc.nome,30,stdin);
         strtok(r_uc.nome, "\n");

         do
         {
            clear_buffer();
            printf("Ano (1,2,3): ");
            scanf("%d",&r_uc.ano);
            if ((r_uc.ano >= 1 && r_uc.ano <= 3) == 0)
            {
               printf ("\nValor Inválido");
               linha();
            }
         }
         while ((r_uc.ano >= 1 && r_uc.ano <= 3) != 1);

         do
         {
            clear_buffer();
            printf("Semestre (1,2): ");
            scanf("%d",&r_uc.semestre);
            if ((r_uc.semestre >= 1 && r_uc.semestre <= 2) == 0)
            {
               printf ("\nValor Inválido");
               linha();
            }
         }
         while ((r_uc.semestre >= 1 && r_uc.semestre <= 2) != 1);

         do
         {
            clear_buffer();
            printf("ECTS : ");
            scanf("%d",&r_uc.ects);
            if ((r_uc.ects >= 1 && r_uc.ects <= 6) == 0)
            {
               printf ("\nValor Inválido");
               linha();
            }
         }
         while ((r_uc.ects >= 1 && r_uc.ects <= 6) != 1);

         clear_buffer();
         printf("Docente: ");
         fgets(r_uc.docente,30,stdin);
         strtok(r_uc.docente, "\n");

         clear_buffer();
         printf("Tutor:   ");
         fgets(r_uc.tutor,30,stdin);
         strtok(r_uc.tutor, "\n");

         r_uc.eliminado = 0;  // Quando eh criado fica a 0, se for eliminado passa a 1

         if (gravar("Inserir UC ") == 'S')
         {
            // Acrescenta registo no fim do ficheiro  "ucs.dat"
            fwrite(&r_uc, sizeof(r_uc),1,arq);
         }
      }
      fechar_ficheiro(arq);
   }
}


/*
   Mostrar registo de UC
*/
void mostrar_uc(UCS* p_uc)
{

    linha();
    printf("UC:       %d", p_uc->numero);
    linha();
    printf("Nome:     %s", p_uc->nome);
    linha();
    linha();
    printf("Ano:      %d", p_uc->ano);
    linha();
    printf("Semestre: %d", p_uc->semestre);
    linha();
    printf("ECTS:     %d", p_uc->ects);
    linha();
    linha();
    printf("Docente:  %s", p_uc->docente);
    linha();
    printf("Tutor:    %s", p_uc->tutor);

}


/*
   Consulta UC
      - Modificar     0 - Nao   1 - Sim
      - Numero a consultar
      - Eliminados    0 - Nao   1 - Sim
      - Silencio      0 - Nao   1 - Sim (nao envia mensagens para o ecran)
                      Esta opcao eh usada para testar e retornar o nome noutras funcoes
*/
int cons_uc(char* p_nome,int p_modificar, int p_numero, int p_eliminado, int p_silencio)
{
   UCS r_uc;
   int l_existe = 0;

   if (p_silencio == 0)
   {
      if (p_modificar == 0)
      {
         cabecalho("UCs: Consultar");
      }
      else
      {
         cabecalho("UCs: Modificar");
      }
   }

   FILE *arq = abrir_ficheiro("ucs.dat", "rb");
   if (arq != NULL)
   {
      if (p_numero == 0 && p_silencio == 0)
          p_numero =  pergunta_numero("Numero UC ( 0-Todos) ? ");

      while ( fread( &r_uc, 1, sizeof(r_uc), arq ) == sizeof(r_uc) )
      {
         if ( (r_uc.numero == p_numero || p_numero == 0 ) && (r_uc.eliminado == p_eliminado ) )
         {
            l_existe = 1;
            strcpy(p_nome, r_uc.nome);
            if (p_silencio == 0)
            {
               if (p_modificar == 0)
               {
                  cabecalho("UCs: Consultar");
               }
               else
               {
                  cabecalho("UCs: Modificar");
               }
               mostrar_uc(&r_uc);
               pause();
            }
         }
      }
      fechar_ficheiro(arq);
      if (p_silencio == 0 && l_existe == 0)
      {
         linha();
         mensagem ("Registo Inexistente");
      }
   }

   return l_existe;
}


/*
   Modificar UC
*/
void mod_uc()
{
   UCS r_uc;
   char l_nome[30];

   cabecalho("UCs: Modificar");
   int l_numero =  pergunta_numero("Numero (0-Sair)? ");

   if (l_numero != 0 && (cons_uc(l_nome,1, l_numero, 0, 0) == 1))
   {
      FILE *arq = abrir_ficheiro("ucs.dat", "r+b");
      if (arq != NULL)
      {
         while ( fread( &r_uc, 1, sizeof(r_uc), arq ) == sizeof(r_uc) )
         {
            if ( r_uc.numero == l_numero )
            {
               clear_buffer();
               printf("Nome:    ");
               fgets(r_uc.nome,30,stdin);

               do
               {
                  clear_buffer();
                  printf("Ano: (1,2,3)  ");
                  scanf("%d",&r_uc.ano);
                  if ((r_uc.ano >= 1 && r_uc.ano <= 3) == 0)
                  {
                     printf ("\nValor Inválido");
                     linha();
                  }
               }
               while ((r_uc.ano >= 1 && r_uc.ano <= 3) != 1);

               do
               {
                  clear_buffer();
                  printf("Semestre (1,2): ");
                  scanf("%d",&r_uc.semestre);
                  if ((r_uc.semestre >= 1 && r_uc.semestre <= 2) == 0)
                  {
                     printf ("\nValor Inválido");
                     linha();
                  }
               }
               while ((r_uc.semestre >= 1 && r_uc.semestre <= 2) != 1);

               do
               {
                  clear_buffer();
                  printf("ECTS (1-6): ");
                  scanf("%d",&r_uc.ects);
                  if ((r_uc.ects >= 1 && r_uc.ects <= 6) == 0)
                  {
                     printf ("\nValor Inválido");
                     linha();
                  }
               }
               while ((r_uc.ects >= 1 && r_uc.ects <= 6) != 1);

               clear_buffer();
               printf("Docente: ");
               fgets(r_uc.docente,30,stdin);

               clear_buffer();
               printf("Tutor:   ");
               fgets(r_uc.tutor,30,stdin);

               if (gravar("Modificar UC") == 'S')
               {
                  fseek(arq,-sizeof(r_uc),SEEK_CUR);
                  fwrite(&r_uc, sizeof(r_uc),1,arq);
               }
               fechar_ficheiro(arq);
            }
         }
      }
   }
   else
   {
      linha();
      mensagem ("Registo Inexistente");
   }
}


/*
   Eliminar UC
*/
void eli_uc()
{
   UCS r_uc;

   cabecalho("UCs: Eliminar");

   FILE *arq = abrir_ficheiro("ucs.dat", "r+b");
   if (arq != NULL)
   {
      int l_numero =  pergunta_numero("Numero: ");
      int l_existe = 0;

      while ( fread( &r_uc, 1, sizeof(r_uc), arq ) == sizeof(r_uc) )
      {
         if ( r_uc.numero == l_numero && r_uc.eliminado == 0 )
         {
            mostrar_uc(&r_uc);
            l_existe = 1;
            linha();

            // Valida integridade referencial
            // 0 - Aluno 1 - UC
            if (valida_int_referencial( 1,r_uc.numero) == 0)
            {
               if (gravar("Eliminar UC") == 'S')
               {
                  r_uc.eliminado = 1;
                  fseek(arq,-sizeof(r_uc),SEEK_CUR);
                  fwrite(&r_uc, sizeof(r_uc),1,arq);
               }
            }
            else
            {
               mensagem ("Esta UC nao pode ser eliminada, tem inscricoes ativas");
            }
            break;
         }
      }
      fechar_ficheiro(arq);
      if (l_existe == 0)
      {
         linha();
         mensagem ("Registo Inexistente");
      }
   }
}


// Fim ficheiro "ucs.c"

