/*
UC: 21178 - Laboratorio de Programacao
Ano 2018/19    AF 2

Sistema de gestao de inscricoes na LEI - Universidade Aberta

Grupo 7: Los Mariachis

- Nelson Domingos n. 1002960
- Sonia Violante  n. 1100135
- Claudia Pires   n. 1303334
- Paulo Silva     n. 1303918

Ficheiro: valida.c

MODULO 8 - VALIDA
*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include "globals.h"
#include "ucs.h"
#include "inscricoes.h"


/*
   Valida Integridade Referencial
   0 - Aluno - Nao se pode eliminiar um aluno com inscricoes ativas
   1 - UC    - Nao se pode eliminiar uma UC com inscricoes ativas
*/
int valida_int_referencial(int p_tipo, int p_numero)
{
   INSCRICOES r_inscricao;
   int l_existe = 0;

   FILE *arq = abrir_ficheiro("inscricoes.dat","rb");
   if (arq != NULL)
   {
      while ( fread( &r_inscricao, 1, sizeof(r_inscricao), arq ) == sizeof(r_inscricao) )
      {
         if (r_inscricao.eliminado == 0)
         {
            if ((p_tipo == 0 && r_inscricao.n_aluno == p_numero ) ||
                (p_tipo == 1 && r_inscricao.n_uc == p_numero))
            {
               l_existe = 1;
               break;
            }
         }
      }
      fechar_ficheiro(arq);
   }
   return l_existe;
}


/*
   Valida inscrição: Valida chave duplicada (n_aluno, n_uc, ano)
*/
int valida_inscricao(int p_n_aluno, int p_n_uc, int p_ano)
{
   INSCRICOES r_inscricao;
   int l_existe = 0;

   FILE *arq = abrir_ficheiro("inscricoes.dat","rb");
   if (arq != NULL)
   {
      while ( fread( &r_inscricao, 1, sizeof(r_inscricao), arq ) == sizeof(r_inscricao) )
      {
         if (r_inscricao.n_aluno == p_n_aluno &&
             r_inscricao.n_uc == p_n_uc &&
             r_inscricao.ano == p_ano)
         {
            if (r_inscricao.eliminado == 0)
            {
               l_existe = 1;
            }
            else
            {
               l_existe = 2;
            }
         }
      }
      fechar_ficheiro(arq);
   }

   return l_existe;
}


/*
   Funcao para retornar os ects de uma UC
*/
int valor_ects_uc(int p_uc)
{
   UCS r_uc;

   FILE *arq = abrir_ficheiro("ucs.dat","rb");
   if (arq != NULL)
   {
      while ( fread( &r_uc, 1, sizeof(r_uc), arq ) == sizeof(r_uc) )
      {
         if (r_uc.numero == p_uc)
         {
            break;
         }
      }
      fechar_ficheiro(arq);
   }

   return r_uc.ects;
}


/*
   Valida ects
*/
int valida_ects(int p_n_aluno, int p_n_uc,int p_ano)
{
   INSCRICOES r_inscricao;

   int l_ano_max = 0;
   int l_ano_min = 9999;
   int l_total_ects = 0;

   int l_erro = 0;
   int l_ects = 0;


   FILE *arq = abrir_ficheiro("inscricoes.dat","rb");
   if (arq != NULL)
   {
      while ( fread( &r_inscricao, 1, sizeof(r_inscricao), arq ) == sizeof(r_inscricao) )
      {
         if (r_inscricao.n_aluno == p_n_aluno && r_inscricao.eliminado == 0)
         {
            if(r_inscricao.ano > l_ano_max)
            {
               l_ano_max = r_inscricao.ano;
               l_total_ects = 0;
            }
            if(r_inscricao.ano < l_ano_min)
            {
               l_ano_min = r_inscricao.ano;
            }
            if ( r_inscricao.ano == l_ano_max )
            {
               l_total_ects = l_total_ects + valor_ects_uc(r_inscricao.n_uc);
            }
         }
      }
      fechar_ficheiro(arq);
   }

   // Trazer valor de ECTS da nova UC
   l_ects = valor_ects_uc(p_n_uc);
   if (l_ano_max == l_ano_min) // Se o ano max e min sao iguais entao eh o 1o ano inscrito
   {
      if ((l_total_ects + l_ects) > 60)
      {
         l_erro = 1;
         mensagem("Valor total ECTS 1 ano excedido (Max.60)");
      }
   }
   else
   {
      if ((l_total_ects + l_ects) > 84)
      {
         l_erro = 1;
         mensagem("Valor total ECTS excedido (Max.84)");
      }
   }

   return l_erro;
}


// Fim ficheiro "valida.c"

